
export function getElementPositionData(elem: HTMLElement){
  const rect = elem.getBoundingClientRect()
  return {left: rect.left, top: rect.top, width: rect.width, height: rect.height}
}

export function sendElementPositionMessage(type: string, elem: HTMLElement, index?: number){
  const bounds = getElementPositionData(elem)
  window.parent.postMessage({
    type,
    index: index,
    ...bounds
  }, "*")
}

export function sendMessage(type: string, message: any){
  window.parent.postMessage({
    type,
    ...message
  }, "*")
}